/*!
 * echarts-extension-bingmaps 
 * @version 1.0.3
 * @author andybuibui
 * 
 * MIT License
 * 
 * Copyright (c) 2019-2024 andybuibui
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("echarts/lib/echarts")):"function"==typeof define&&define.amd?define(["exports","echarts"],e):e(((t="undefined"!=typeof globalThis?globalThis:t||self).echarts=t.echarts||{},t.echarts.bingmap={}),t.echarts)}(this,(function(t,e){"use strict";var o=e.version.split("."),n=o[0]>4,i="bingmap";var a={type:i,setBingMap:function(t){this.__bingmap=t},getBingMap:function(){return this.__bingmap},setEChartsLayer:function(t){this.__echartsLayer=t},getEChartsLayer:function(){return this.__echartsLayer},setCenterAndZoom:function(t,e){this.option.viewOption.center=t,this.option.viewOption.zoom=e},centerOrZoomChanged:function(t,e){var o,n,i=this.option.viewOption;return n=i.center,!((o=t)&&n&&o[0]===n[0]&&o[1]===n[1]&&e===i.zoom)},defaultOption:{viewOption:{center:[113.493471,23.169598],zoom:5},mapOption:{customMapStyle:{}}}},s=n?e.ComponentModel.extend(a):a,r={type:i,init:function(){this._isFirstRender=!0},render:function(t,e,o){var n=!0,i=t.getBingMap(),a=o.getZr().painter.getViewportRoot(),s=t.coordinateSystem,r=function(e){if(!n){var i=a.parentNode.parentNode.parentNode,r=[-parseInt(i.style.left,10)||0,-parseInt(i.style.top,10)||0];a.style.left=r[0]+"px",a.style.top=r[1]+"px",s.setMapOffset(r),t.__mapOffset=r,o.dispatchAction({type:"bingmapRoam"})}};Microsoft.Maps.Events.removeHandler(this._oldViewChangeHandler),this._oldViewChangeHandler=Microsoft.Maps.Events.addHandler(i,"viewchangeend",r),Microsoft.Maps.Events.removeHandler(this._oldmapresize),this._oldmapresize=Microsoft.Maps.Events.addHandler(i,"mapresize",r),this._isFirstRender=n=!1,this.__viewChangeHandler=r},dispose:function(){var t=this.__model;t&&(t.getBingMap().dispose(),t.setBingMap(null),t.setEChartsLayer(null),t.coordinateSystem&&(t.coordinateSystem.setBingMap(null),t.coordinateSystem=null)),delete this.__viewChangeHandler}},p=n?e.ComponentView.extend(r):r;function c(t,e){this._bingmap=t,this.dimensions=["lng","lat"],this._mapOffset=[0,0],this._api=e}function d(t,o){return o=o||[0,0],e.util.map([0,1],(function(e){var n=o[e],i=t[e]/2,a=[],s=[];return a[e]=n-i,s[e]=n+i,a[1-e]=s[1-e]=o[1-e],Math.abs(this.dataToPoint(a)[e]-this.dataToPoint(s)[e])}),this)}c.prototype.dimensions=["lng","lat"],c.prototype.setZoom=function(t){this._zoom=t},c.prototype.setCenter=function(t){this._center=this._bingmap.tryLocationToPixel(new Microsoft.Maps.Location(t[1],t[0]))},c.prototype.setMapOffset=function(t){this._mapOffset=t},c.prototype.getBingMap=function(){return this._bingmap},c.prototype.dataToPoint=function(t){var e=new Microsoft.Maps.Location(t[1],t[0]),o=this._bingmap.tryLocationToPixel(e,Microsoft.Maps.PixelReference.control),n=this._mapOffset;return[o.x-n[0],o.y-n[1]]},c.prototype.pointToData=function(t){var e=this._mapOffset,o=this._bingmap.tryPixelToLocation({x:t[0]+e[0],y:t[1]+e[1]},Microsoft.Maps.PixelReference.control);return[o.longitude,o.latitude]},c.prototype.getViewRect=function(){var t=this._api;return new e.graphic.BoundingRect(0,0,t.getWidth(),t.getHeight())},c.prototype.getRoamTransform=function(){return e.matrix.create()},c.prototype.prepareCustoms=function(){var t=this.getViewRect();return{coordSys:{type:"bingmap",x:t.x,y:t.y,width:t.width,height:t.height},api:{coord:e.util.bind(this.dataToPoint,this),size:e.util.bind(d,this)}}},c.dimensions=c.prototype.dimensions,c.create=function(t,e){var o,n=e.getDom();t.eachComponent("bingmap",(function(t){var i=e.getZr().painter,a=i.getViewportRoot();if("undefined"==typeof Microsoft||void 0===Microsoft.Maps||void 0===Microsoft.Maps.Map)throw new Error("It seems that Bing Map API has not been loaded completely yet.");if(o)throw new Error("Only one bingmap component can exist");if(!t.__bingmap){var s=n.querySelector(".ec-extension-bing-map");a.className="ms-composite",a.style.visibility="hidden",s&&(a.style.left="0px",a.style.top="0px",a.style.width="100%",a.style.height="100%",a.style.position="absolute",n.removeChild(s)),(s=document.createElement("div")).style.cssText="position:absolute;top:0;left:0;right:0;bottom:0;",s.className="ec-extension-bing-map",n.appendChild(s);var r=t.__bingmap=new Microsoft.Maps.Map(s),p=t.get("mapOption")||{};r.setOptions(p),s.querySelector(".MicrosoftMap").appendChild(a),a.style.visibility="",i.getViewportRootOffset=function(){return{offsetLeft:0,offsetTop:0}}}var d=t.__bingmap,f=t.get("viewOption"),m=f.center,l=f.zoom,h=[void 0!==m.lng?m.lng:m[0],void 0!==m.lat?m.lat:m[1]];if(m&&l){var g=d.getCenter(),u=d.getZoom();if(t.centerOrZoomChanged([g.longitude,g.latitude],u)){var y=new Microsoft.Maps.Location(h[1],h[0]);d.setView({center:y,zoom:l})}}(o=new c(d,e)).setMapOffset(t.__mapOffset||[0,0]),o.setZoom(l),o.setCenter(m),t.coordinateSystem=o})),t.eachSeries((function(t){"bingmap"===t.get("coordinateSystem")&&(t.coordinateSystem=o)}))};function f(t){(!n||5==o[0]&&o[1]<4)&&t.registerLayout((function(t){t.eachSeriesByType("pie",(function(t){var e=t.coordinateSystem,o=t.getData(),n=o.mapDimension("value");if(e&&e.type===i){var a=t.get("center"),s=e.dataToPoint(a),r=s[0],p=s[1];o.each(n,(function(t,e){var n=o.getItemLayout(e);n.cx=r,n.cy=p}))}}))})),n?t.registerComponentModel(s):t.extendComponentModel(s),n?t.registerComponentView(p):t.extendComponentView(p),t.registerCoordinateSystem(i,c),t.registerAction({type:i+"Roam",event:i+"Roam",update:"updateLayout"},(function(t,e){e.eachComponent("bingmap",(function(t){var e=t.getBingMap(),o=e.getCenter();t.setCenterAndZoom([o.longitude,o.latitude],e.getZoom())}))}))}n?e.use(f):f(e),t.name="echarts-extension-bingmaps",t.version="1.0.3"}));
//# sourceMappingURL=echarts-extension-bingmaps.min.js.map
